Ensure cp -pR --parents isn't too generous with parent permissions.
authorPaul Eggert <eggert@cs.ucla.edu>
Fri, 15 Dec 2006 08:44:58 +0000 (09:44 +0100)
committerJim Meyering <jim@meyering.net>
Fri, 15 Dec 2006 08:44:58 +0000 (09:44 +0100)
* tests/cp/Makefile.am (TESTS): Add parent-perm-race.
* tests/cp/parent-perm-race: New file.
Signed-off-by: Jim Meyering <jim@meyering.net>
ChangeLog
tests/cp/Makefile.am
tests/cp/parent-perm-race [new file with mode: 0755]

index e8fc2f2..7a86550 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2006-12-14  Paul Eggert  <eggert@cs.ucla.edu>
+
+       Ensure cp -pR --parents isn't too generous with parent permissions.
+       * tests/cp/Makefile.am (TESTS): Add parent-perm-race.
+       * tests/cp/parent-perm-race: New file.
+
 2006-12-14  Jim Meyering  <jim@meyering.net>
 
        * tests/chgrp/default-no-deref: Don't assume that files are created
index 1fb58de..e91ea0d 100644 (file)
@@ -21,7 +21,7 @@
 AUTOMAKE_OPTIONS = 1.1 gnits
 
 TESTS = \
-  open-perm-race \
+  open-perm-race parent-perm-race \
   backup-dir \
   src-base-dot \
   sparse \
diff --git a/tests/cp/parent-perm-race b/tests/cp/parent-perm-race
new file mode 100755 (executable)
index 0000000..80c95a6
--- /dev/null
@@ -0,0 +1,68 @@
+#!/bin/sh
+# Make sure cp -pR --parents isn't too generous with parent permissions.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  cp --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp;tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+umask 022
+mkdir -p a d || framework_failure=1
+mkfifo a/fifo || {
+  echo "$0: fifos not supported; skipping this test." 1>&2
+  (exit 77); exit 77
+}
+
+# Copy a fifo's contents.  That way, we can examine d/a's
+# state while cp is running.
+cp -p -R --copy-contents --parents a d &
+cp_pid=$!
+
+(
+  # Now 'cp' is reading the fifo.
+  # Check the permissions of the temporary destination
+  # directory that 'cp' has made.
+  ls -ld d/a >d/ls.out
+
+  # Close the fifo so that "cp" can continue.  But output first,
+  # before exiting, otherwise some shells would optimize away the file
+  # descriptor that holds the fifo open.
+  echo foo
+) >a/fifo
+
+case `cat d/ls.out` in
+d???--[-S]--[-S]*)
+  fail=0;;
+*)
+  fail=1;;
+esac
+
+wait $cp_pid || fail=1
+
+(exit $fail); exit $fail